/**
 * Primer pravljanja liste koja moze da se napravi od niza istog tipa elemenata
 * i koja moze da napravi niz od svog sadrzaja.
 *
 */
public class ListeKonverzija {

	public static void main(String[] args) {
		// demonstracija kako izgleda stampajniz
		String[] ptice = new String[]{"golub", "vrana", "vrabac"};
		System.out.println("niz:" + ptice); //toString od niza
		stampajNiz(ptice);
		
		System.out.println();
		
		// pravimo novu listu od postojeceg niza
		ListaN listaP = new ListaN();
		listaP.dodajSve(ptice);
		System.out.println(listaP);
		listaP.dodaj("sova");
		System.out.println(listaP);

		System.out.println();

		// ako nam je bitan redosled, onda koristimo drugi metod
		ListaN druga = new ListaN();
		druga.dodajSveUIstomRedosledu(ptice);
		System.out.println(druga);

		// mozemo dodavati i elemente druge liste
		druga.dodajSve(listaP);
		System.out.println(druga);
		
		System.out.println();
		
		// mozemo direktno u konstruktor da prosledimo niz
		ListaN treca = new ListaN(ptice);
		System.out.println(treca);
		
		System.out.println();
		
		// pravimo listu koju cemo pretvarati u niz
		ListaN lista = new ListaN();

		lista.dodaj("vrabac");
		lista.dodaj("vrana");
		lista.dodaj("golub");
		lista.dodaj("albatros");

		System.out.println(lista);

		String[] niz = lista.napraviNiz();
		System.out.println("niz:" + niz); //toString od niza
		stampajNiz(niz);

		String[] niz2 = lista.napraviNiz();
		System.out.println("niz:" + niz2); //toString od niza
		stampajNiz(niz2);
		System.out.println("nizovi su jednaki:"+niz.equals(niz2));
		
		System.out.println();				
	}

	public static void stampajNiz(String[] niz) {
		System.out.print("sadzaj niza:");
		for (String s : niz) {
			System.out.print('"' + s + '"' + ' ');
		}
		System.out.println();
	}

}

/**
 * Lista strigova koja omogucava da njen sadrzaj pretvori u niz, kao i da se
 * lista napravi od niza, ili da se dodaju svi elementi iz nekog niza.
 */
class ListaN {

	class Element {
		String info;
		Element veza;

		public Element(String s) {
			info = s;
			veza = null;
		}
	}

	// pokazivac na prvi element liste
	Element prvi;

	// interni brojac koji pomaze kod nekih operacija
	int brojElemenata;

	/** Kreira praznu listu. */
	public ListaN() {
		this.prvi = null;
		this.brojElemenata = 0;
	}

	/** Kreira listu u kojoj je pocetni sadrzaj iskopiran iz prosledjenog niza */
	public ListaN(String[] stringovi) {
		this.dodajSveUIstomRedosledu(stringovi);
	}

	public String toString() {
		String rez = "ListaN: [ ";
		Element tekuci = prvi;
		while (tekuci != null) {
			rez += '"' + tekuci.info + "\" ";
			tekuci = tekuci.veza;
		}
		rez += "]";
		return rez;
	}

	/** vraca broj elemenata u listi */
	public int velicina() {
		return brojElemenata;
	}

	/** Vraca da li je lista prazna */
	public boolean jePrazna() {
		return prvi == null;
	}

	public void dodaj(String str) {
		Element novi = new Element(str);
		novi.veza = prvi;
		prvi = novi;
		brojElemenata++;
	}

	public void dodajSve(String[] stringovi) {
		for (String s : stringovi) {
			dodaj(s);
		}
	}

	public void dodajSveUIstomRedosledu(String[] stringovi) {
		for (int i = stringovi.length - 1; i >= 0; i--) {
			dodaj(stringovi[i]);
		}
	}

	public String[] napraviNiz() {
		String[] niz = new String[brojElemenata];
		Element tekuci = prvi;
		int br = 0;
		while (tekuci != null) {
			niz[br] = tekuci.info;
			br++;
			tekuci = tekuci.veza;
		}
		return niz;
	}
	
	public void dodajSve(ListaN lista) {
		Element tekuci = lista.prvi;
		while (tekuci != null) {
			dodaj(tekuci.info);
			tekuci = tekuci.veza;
		}
	}

}