/**
 * Progam predstavlja primere podele liste na dve, samo premestanje pokazivaca,
 * odnosno bez zauzimanja memorije za nove elemente.
 */
public class ListePodela {

	static void testNaizmenicnoPrviParan() {
		DeljivaLista l = new DeljivaLista();
		int n = 5;
		for (int i = 0; i < n; i++) {
			l.dodaj(i);
		}
		System.out.println("originalna lista:");
		System.out.println(l);

		System.out.println("nove liste:");
		DeljivaLista l2 = l.izdvojParne();
		System.out.println(l);
		System.out.println(l2);
	}

	static void testNaizmenicnoPrviNeParan() {
		DeljivaLista l = new DeljivaLista();
		int n = 5;
		for (int i = 0; i < n; i++) {
			l.dodaj(i + 1);
		}
		System.out.println("originalna lista:");
		System.out.println(l);

		System.out.println("nove liste:");
		DeljivaLista l2 = l.izdvojParne();
		System.out.println(l);
		System.out.println(l2);
	}

	static void testSviParni() {
		DeljivaLista l = new DeljivaLista();
		int n = 5;
		for (int i = 0; i < n; i++) {
			l.dodaj(i * 2);
		}
		System.out.println("originalna lista:");
		System.out.println(l);

		System.out.println("nove liste:");
		DeljivaLista l2 = l.izdvojParne();
		System.out.println(l);
		System.out.println(l2);
	}

	static void testSviNeparni() {
		DeljivaLista l = new DeljivaLista();
		int n = 5;
		for (int i = 0; i < n; i++) {
			l.dodaj(i * 2 + 1);
		}
		System.out.println("originalna lista:");
		System.out.println(l);

		System.out.println("nove liste:");
		DeljivaLista l2 = l.izdvojParne();
		System.out.println(l);
		System.out.println(l2);
	}

	static void testUzastopniParni() {
		DeljivaLista l = new DeljivaLista();
		l.dodaj(7);
		int n = 3;
		for (int i = 0; i < n; i++) {
			l.dodaj(i * 2);
		}
		l.dodaj(5);
		l.dodaj(8);
		l.dodaj(5);

		System.out.println("originalna lista:");
		System.out.println(l);

		System.out.println("nove liste:");
		DeljivaLista l2 = l.izdvojParne();
		System.out.println(l);
		System.out.println(l2);
	}

	static void testPrvihN1() {
		DeljivaLista l = new DeljivaLista();
		int n = 5;
		for (int i = 0; i < n; i++) {
			l.dodaj(i);
		}

		System.out.println("originalna lista:");
		System.out.println(l);

		System.out.println("nove liste:");
		DeljivaLista l2 = l.izdvojPrvihN(1);
		System.out.println(l);
		System.out.println(l2);
	}
	
	static void testPrvihN0() {
		DeljivaLista l = new DeljivaLista();
		int n = 5;
		for (int i = 0; i < n; i++) {
			l.dodaj(i);
		}

		System.out.println("originalna lista:");
		System.out.println(l);

		System.out.println("nove liste:");
		DeljivaLista l2 = l.izdvojPrvihN(0);
		System.out.println(l);
		System.out.println(l2);
	}
	
	static void testPrvihN3() {
		DeljivaLista l = new DeljivaLista();
		int n = 5;
		for (int i = 0; i < n; i++) {
			l.dodaj(i);
		}

		System.out.println("originalna lista:");
		System.out.println(l);

		System.out.println("nove liste:");
		DeljivaLista l2 = l.izdvojPrvihN(3);
		System.out.println(l);
		System.out.println(l2);
	}
	
	static void testPrvihNN() {
		DeljivaLista l = new DeljivaLista();
		int n = 5;
		for (int i = 0; i < n; i++) {
			l.dodaj(i);
		}

		System.out.println("originalna lista:");
		System.out.println(l);

		System.out.println("nove liste:");
		DeljivaLista l2 = l.izdvojPrvihN(n);
		System.out.println(l);
		System.out.println(l2);
	}
	
	static void testPrvihNN1() {
		DeljivaLista l = new DeljivaLista();
		int n = 5;
		for (int i = 0; i < n; i++) {
			l.dodaj(i);
		}

		System.out.println("originalna lista:");
		System.out.println(l);

		System.out.println("nove liste:");
		DeljivaLista l2 = l.izdvojPrvihN(n+1);
		System.out.println(l);
		System.out.println(l2);
	}
	
	static void testPrvihN2N() {
		DeljivaLista l = new DeljivaLista();
		int n = 5;
		for (int i = 0; i < n; i++) {
			l.dodaj(i);
		}

		System.out.println("originalna lista:");
		System.out.println(l);

		System.out.println("nove liste:");
		DeljivaLista l2 = l.izdvojPrvihN(2*n);
		System.out.println(l);
		System.out.println(l2);
	}
	
	public static void main(String[] args) {
		testNaizmenicnoPrviParan();
		System.out.println();
		testNaizmenicnoPrviNeParan();
		System.out.println();
		testSviParni();
		System.out.println();
		testSviNeparni();
		System.out.println();
		testUzastopniParni();
		System.out.println();
		System.out.println("Izdvajanje prvih 0:");
		testPrvihN0();
		System.out.println("Izdvajanje prvih 1:");
		testPrvihN1();
		System.out.println("Izdvajanje prvih 3:");
		testPrvihN3();
		System.out.println("Izdvajanje prvih N:");
		testPrvihNN();
		System.out.println("Izdvajanje prvih N+1:");
		testPrvihNN1();
		System.out.println("Izdvajanje prvih 2*N:");
		testPrvihN2N();
	}

}

/**
 * Lista brojeva koja omogucava da se iz nje izdvoji nova lista u kojoj se
 * nalaze samo parni brojevi.
 */
class DeljivaLista {

	class Element {
		int info;
		Element veza;

		public Element(int br) {
			info = br;
			veza = null;
		}

		public String toString() {
			return info + "";
		}

	}

	Element prvi;

	public DeljivaLista() {
		prvi = null;
	}

	public void dodaj(int br) {
		Element novi = new Element(br);
		novi.veza = prvi;
		prvi = novi;
	}

	public String toString() {
		String rez = "DeljivaLista: [ ";
		Element tekuci = prvi;
		while (tekuci != null) {
			rez += tekuci.info + " ";
			tekuci = tekuci.veza;
		}
		rez += "]";
		return rez;
	}

	/**
	 * Metod pravi novu listu koja se sastoji od izdvojenih parnih elemenata ove
	 * liste, pri cemu se ne zauzima nova memorija. Nakon poziva ovog metoda
	 * lista na kojoj je pozvan se sastoji samo od neparnih elemenata.
	 * 
	 * @return lista parnih elemenata ove liste
	 */
	public DeljivaLista izdvojParne() {
		// buduci rezultat operacije
		DeljivaLista parni = new DeljivaLista();

		// da bi dodavali na kraj mozemo imati lokalnu
		// promenljivu koja pamti gde je kraj
		Element parniKraj = null;

		Element tek, pret;

		while (prvi != null && prvi.info % 2 == 0) {
			tek = prvi;
			prvi = prvi.veza;
			if (parni.prvi == null) {
				parni.prvi = tek;
				parniKraj = tek;
				tek.veza = null;
			} else {
				parniKraj.veza = tek;
				tek.veza = null;
				parniKraj = tek;
			}
		}

		if (prvi != null) {
			tek = prvi;
			while (tek.veza != null) {
				pret = tek;
				tek = tek.veza;
				if (tek.info % 2 == 0) {
					pret.veza = tek.veza;
					if (parni.prvi == null) {
						parni.prvi = tek;
						tek.veza = null;
						parniKraj = tek;
					} else {
						parniKraj.veza = tek;
						tek.veza = null;
						parniKraj = tek;
					}
					tek = pret;
				}
			}
		}

		return parni;
	}

	/**
	  * Vraca novu listu koja se sastoji od prvih `n` elemenata
	  * ove liste, a ova lista se nakon poziva sastoji od ostatka.
	  * U slucaju da je `n` nepozitivan broj bice vracena prazna lista,
	  * a u slucaju da je `n` vece ili jednako broju elemenata u listi
	  * nova lista ce se sastojati od cele ove liste, a ova ce ostati
	  * prazna.
	  */
	public DeljivaLista izdvojPrvihN(int n) {
		DeljivaLista rezultat = new DeljivaLista();
		if (n <= 0) {
			return rezultat;
		}
		
		rezultat.prvi = prvi;

		int brojac = 0;
		Element poslednji = prvi;
		while (poslednji != null && brojac < n - 1) {
			poslednji = poslednji.veza;
			brojac++;
		}
		if (poslednji != null) {
			prvi = poslednji.veza;
			poslednji.veza = null;
		} else {
			prvi = null;
		}
		return rezultat;
	}
}
